<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 16/09/2015
 * Time: 15:59
 */

namespace Controller;


use Util\Messages;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response\Notification;

class StructureType  extends \Generated\Controller\StructureType{
    /**
     * @var \Util\Utilities
     */
    private $environment;
    /**
     * @var \Service\StructureType
     */
    private $structureType;

    public function __construct(Manager $dataSourceManager, \Util\Utilities $environment,\Service\StructureType $structureType) {
        parent::__construct($dataSourceManager);
        $this->environment = $environment;
        $this->structureType = $structureType;
    }
    public function find(Request\Filter $request, Response $response){
        $request->getFilterCriteria()->addCondition("ORGANIZATION", "=", $this->environment->getCurrentOrganizationId());
        parent::find($request, $response);
    }
    public function save(Request $request, Response $response, $showMessage = false) {
        try{
            $rows = $request->getDataSet()->getRows();
            foreach($rows as &$row){
                $row['ORGANIZATION'] = $this->environment->getCurrentOrganizationId();
            }
            parent::save($request, $response, false);
            $response->addNotification(new Notification(\Util\Messages::SUC_SUCCESSFUL_SAVED_STRUCTURE_TYPE, Notification::TYPE_SUCCESS));
        }catch (\Exception $e){
            $response->addMessage(new Response\Message('Erro: '.$e->getMessage(),Response\Message::TYPE_ERROR));
        }
    }
    public function delete(Request $request, Response $response, $showMessage = false) {
        try{
            $rows = $request->getDataSet()->getRows();
            foreach ($rows as $row){
               $check =  $this->structureType->checkStructureTypeInUser($row['ID']);
                if($check){
                    throw new \Exception($check);
                }
            }
            $response->addNotification(new Notification(\Util\Messages::SUC_SUCCESSFUL_DELETED_STRUCTURE_TYPE, Notification::TYPE_SUCCESS));
            parent::delete($request, $response, $showMessage);
        }catch (\Exception $e){
            $response->addMessage(new Response\Message('Erro: '.$e->getMessage(),Response\Message::TYPE_ERROR));
        }
    }
} 