<?php
/**
 * Created by PhpStorm.
 * User: rafaelrapalo
 * Date: 27/05/14
 * Time: 15:14
 */

namespace Service;


use Doctrine\ORM\EntityManager;

class Contact {

    protected  $entityManager;
    protected  $environment;
    protected  $contactFactory;

    public function __construct(EntityManager $entityManager, \Util\Utilities $environment,\Factory\Contact $contactFactory){
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->contactFactory = $contactFactory;
    }

    public function createContact($sponsorId,$address,$city,$country,$district,$email,$name,$phone,$state,
                                  $status,$zipCode) {

        $sponsor = $this->entityManager->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\Sponsor')->find($sponsorId);

        $contact = $this->contactFactory->createContact($sponsor, $name, $phone, $address, $district, $email, $city, $zipCode,
            $state, $country, $status, $this->environment->getCurrentOrganization(), $this->environment->getCurrentUser());

        $this->entityManager->persist($contact);
        $this->entityManager->flush();

        return $contact;
    }

    public function updateContact($contactId,$sponsorId,$address,$city,$country,$district,$email,$name,$phone,$state,
                                  $status,$zipCode) {

        $contact= $this->entityManager->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\Contact')->find($contactId);
        $sponsor = $this->entityManager->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\Sponsor')->find($sponsorId);
        
        $contact = $this->contactFactory->updateContact($contact, $sponsor, $name, $phone, $address, $district, $email,
            $city, $zipCode, $state, $country, $status, $this->environment->getCurrentUser());
        $this->entityManager->persist($contact);
        $this->entityManager->flush();


        return $contact;
    }

    public function deleteContact(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Contact $contact) {
        $this->entityManager->remove($contact);
        $this->entityManager->flush();
    }


} 